{
********************************************************************************

MyPlaylist v1.0 by Nikol@y aka NITROGEN

********************************************************************************
}

unit MyPlaylist;

interface

uses
  Windows, Forms, SysUtils, Dialogs, Classes, Controls, Graphics, Types;

type
  TMyPlaylist = class(TCustomControl)
  private
  { Private declarations }
{******************************************************************************}
    FShowDuration, FShowNumber: Boolean;
    FPosition: integer;
    Tracking: integer;
    ItemHeight: integer;
    FItemSelect_BackColor: TColor;
    FItemSelect_FontColor: TColor;
    FItemTrack_BackColor: TColor;
    FItemTrack_FontColor: TColor;
    FItem_BackColor: TColor;
    FItem_FontColor: TColor;
    PlaylistTitles: TStringList;
    PlaylistPaths: TStringList;
{******************************************************************************}
    procedure SetItemSelect_BackColor(Value: TColor);
    procedure SetItemSelect_FontColor(Value: TColor);
    procedure SetItemTrack_BackColor(Value: TColor);
    procedure SetItemTrack_FontColor(Value: TColor);
    procedure SetItem_BackColor(Value: TColor);
    procedure SetItem_FontColor(Value: TColor);
    procedure SetShowDuration(Value: Boolean);
    procedure SetShowNumber(Value: Boolean);
{******************************************************************************}
    function PointInRect(X, Y: Integer; R: TRect): Boolean;
    procedure DblClick; override;
{******************************************************************************}
  protected
  { Protected declarations }
    procedure Paint; override;
  public
  { Public declarations }
    constructor Create(AOwner: TComponent); override;
    procedure Add_File(FileName: string);
    procedure Add_Files(Files: TStrings);
    procedure LoadPlaylist_PLS(FileName: string);
    procedure LoadPlaylist_M3U(FileName: string);
    procedure Delete_Item(Item: integer);
    procedure ClearList;
    function  Count: Integer;
    function  GetTracking: Integer;
    procedure SetNewItemTrack(Item: Integer);
    function  GetItemFiles: TStrings;
    procedure SetPosition(Value: integer);
    function  GetItemHeight: integer;
  published
  { Published declarations }
{******************************************************************************}
    property Enabled;
    property Visible;
    property ShowHint;
    property Font;
{******************************************************************************}
    property ShowDuration: Boolean read FShowDuration write SetShowDuration;
    property ShowNumber: Boolean read FShowNumber write SetShowNumber;
    property ItemSelect_BackColor: TColor read FItemSelect_BackColor write SetItemSelect_BackColor;
    property ItemSelect_FontColor: TColor read FItemSelect_FontColor write SetItemSelect_FontColor;
    property ItemTrack_BackColor: TColor read FItemTrack_BackColor write SetItemTrack_BackColor;
    property ItemTrack_FontColor: TColor read FItemTrack_FontColor write SetItemTrack_FontColor;
    property Item_BackColor: TColor read FItem_BackColor write SetItem_BackColor;
    property Item_FontColor: TColor read FItem_FontColor write SetItem_FontColor;
{******************************************************************************}
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Standard', [TMyPlaylist]);
end;

{TMyPlaylist}

{******************************************************************************}
constructor TMyPlaylist.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Parent:= TForm(AOWner);
  Width := 225;
  Height := 300;

  Font.Name := 'Tahoma';
  Font.Size := 9;
  Font.Height := -12;

  FShowDuration := True;
  FShowNumber := True;
  
  ItemSelect_BackColor := clBlue;
  ItemSelect_FontColor := clYellow;
  ItemTrack_BackColor := clRed;
  ItemTrack_FontColor := clWhite;
  Item_BackColor := clBlack;
  Item_FontColor := clLime;

  PlaylistTitles := TStringList.Create;
  PlaylistPaths := TStringList.Create;

  Tracking := -1;

  Paint;
end;
{******************************************************************************}
procedure TMyPlaylist.Paint;
var
i, j: integer;
s: string;
s_rect: TRect;
begin
inherited;
Canvas.Brush.Color := FItem_BackColor;
Canvas.FillRect(Rect(0,0,Width,Height));

if PlaylistTitles.Count > 0 then
begin
for i := 0 to PlaylistTitles.Count-1 do
begin
if FShowNumber then
//  + 
s := IntToStr(i+1) + '. ' + PlaylistTitles.Strings[i]
else
//  
s := PlaylistTitles.Strings[i];

Canvas.Font := Font;
//  
ItemHeight := 2 + Canvas.TextHeight(s) + 2;

if i = Tracking then
begin
//   
Canvas.Brush.Color := FItemTrack_BackColor;
Canvas.Font.Color := FItemTrack_FontColor
end else
begin
//  
Canvas.Brush.Color := FItem_BackColor;
Canvas.Font.Color := FItem_FontColor
end;
//   
Canvas.FillRect(Rect(0,i*ItemHeight-(FPosition*ItemHeight),Width,(i*ItemHeight+ItemHeight)-(FPosition*ItemHeight)));

if FShowDuration then
// 
Canvas.TextOut((Self.Width-(Canvas.TextWidth('03:15'))-4),(i*ItemHeight+(ItemHeight div 2))-(Canvas.TextHeight(s)div 2)-(FPosition*ItemHeight),'03:15')
else
// . 
Canvas.TextOut((Self.Width-(Canvas.TextWidth(''))-4),(i*ItemHeight+(ItemHeight div 2))-(Canvas.TextHeight(s)div 2)-(FPosition*ItemHeight),'');

//   
s_rect := Rect(1,(i*ItemHeight+(ItemHeight div 2))-(Canvas.TextHeight(s)div 2)-(FPosition*ItemHeight), Self.Width-(Canvas.TextWidth('03:15')+5),(i*ItemHeight+(ItemHeight div 2))-(Canvas.TextHeight(s)div 2)-(FPosition*ItemHeight)+Canvas.TextHeight(s));
//  
DrawTextEx(Canvas.Handle, PChar(s),Length(s), s_rect, DT_WORD_ELLIPSIS, nil);
end;
end;
end;
{******************************************************************************}
procedure TMyPlaylist.SetItemSelect_BackColor(Value: TColor);
begin
FItemSelect_BackColor := Value;
Invalidate;
end;
{******************************************************************************}
procedure TMyPlaylist.SetItemSelect_FontColor(Value: TColor);
begin
FItemSelect_FontColor := Value;
Invalidate;
end;
{******************************************************************************}
procedure TMyPlaylist.SetItemTrack_BackColor(Value: TColor);
begin
FItemTrack_BackColor := Value;
Invalidate;
end;
{******************************************************************************}
procedure TMyPlaylist.SetItemTrack_FontColor(Value: TColor);
begin
FItemTrack_FontColor := Value;
Invalidate;
end;
{******************************************************************************}
procedure TMyPlaylist.SetItem_BackColor(Value: TColor);
begin
FItem_BackColor := Value;
Invalidate;
end;
{******************************************************************************}
procedure TMyPlaylist.SetItem_FontColor(Value: TColor);
begin
FItem_FontColor := Value;
Invalidate;
end;
{******************************************************************************}
procedure TMyPlaylist.Add_File(FileName: string);
begin
If FileExists(FileName) = false then exit;
PlaylistTitles.Add(ExtractFileName(FileName));
PlaylistPaths.Add(FileName);
Paint;
end;
{******************************************************************************}
procedure TMyPlaylist.Add_Files(Files: TStrings);
var
i: integer;
begin
for i := 0 to Files.Count-1 do
begin
if FileExists(Files[i]) = false then exit;
PlaylistTitles.Add(ExtractFileName(Files[i]));
PlaylistPaths.Add(Files[i]);
Paint;
end;
end;
{******************************************************************************}
procedure TMyPlaylist.LoadPlaylist_PLS(FileName: string);
var
f:textfile;
s:string;
i,j:integer;
begin
if lowercase(ExtractFileExt(FileName)) = '.pls' then
begin
assignfile(f,FileName);
reset(f);
repeat
readln(f,s);
s:=trim(s);
if lowercase(copy(s,0,5))='title' then
begin
i:=-1;
repeat
i:=i+1;
until(copy(s,i,1)='=');
PlaylistTitles.Add(copy(s,i+1,length(s)));
end;
if lowercase(copy(s,0,4))='file' then
begin
j:=-1;
repeat
j:=j+1;
until(copy(s,j,1)='=');
PlaylistPaths.Add(copy(s,j+1,length(s)));
end;
until(eof(f)=true);
closefile(f);
Paint;
end;
end;
{******************************************************************************}
function NotFullPathToFullPath(FM3U, FM: string): string;
(*   -> *)
var
  Ress: string;
begin
  Ress := '';
  Result := '';
(* 1-  '\',     *)
  if FM[1] = '\' then
  begin
    Result := ExtractFileDrive(FM3U) + FM;
    exit;
  end else
  begin
(*  m3u +    *)
    if FileExists(ExtractFilePath(FM3U) + FM) then
    begin
      Result := ExtractFilePath(FM3U) + FM;
      exit;
    end;
(*    ?*)
    if FileExists(FM) then
    begin
      Result := FM;
      exit;
    end;
  end;
end;
{******************************************************************************}
procedure TMyPlaylist.LoadPlaylist_M3U(Filename:string);
var List: TStringList;
  i, n: integer;
  s, a: string;
  //ListItem: TListItem;
begin
(* *)
  //Form1.ListView1.Clear;
(*   StringList*)
  List := TStringList.Create;
  try
(*   m3u *)
    List.LoadFromFile(FileName);
    for i := 0 to List.Count - 1 do
    begin
(*  - "#EXTM3U"?  ,    m3u*)
      if List.Strings[0] = '#EXTM3U' then
      begin
        s := List.Strings[i];
        if s[1] <> '#' then
        begin
          //ListItem.SubItems.Add('');
          s := NotFullPathToFullPath(FileName, s);
          //ListItem.SubItems[1] := s;
          PlaylistPaths.Add(s);
        end else
        begin
          if s <> '#EXTM3U' then
          begin
            Delete(S, 1, 8);
            a := '';
            n := 1;
            repeat
              a := a + s[n];
              Inc(n);
            until s[n] = ',';
            Delete(S, 1, Length(a) + 1);
            //ListItem := Form1.ListView1.Items.Add;
            //ListItem.Caption := s;
            PlaylistTitles.Add(s);
            //ListItem.SubItems.Add(Format('%d:%.2d', [StrToInt(a) div 60, StrToInt(a) mod 60]));
          end;
        end;
      end;
    end;
  finally
    List.Free;
  end;
  Paint;
end;
{******************************************************************************}
procedure TMyPlaylist.Delete_Item(Item: integer);
begin
if PlaylistTitles.Count < 0 then exit;
PlaylistTitles.Delete(Item);
PlaylistPaths.Delete(Item);
if Tracking = Item then
Tracking := -1;
Paint;
end;
{******************************************************************************}
procedure TMyPlaylist.ClearList;
begin
if PlaylistTitles.Count > 0 then
PlaylistTitles.Clear;
PlaylistPaths.Clear;
Tracking := -1;
Paint;
end;
{******************************************************************************}
function TMyPlaylist.Count: Integer;
begin
Result := PlaylistTitles.Count;
end;
{******************************************************************************}
function TMyPlaylist.GetTracking: Integer;
begin
Result := Tracking;
end;
{******************************************************************************}
procedure TMyPlaylist.SetNewItemTrack(Item: integer);
begin
Tracking := Item;
Paint;
end;
{******************************************************************************}
function TMyPlaylist.GetItemFiles: TStrings;
begin
Result := PlaylistPaths;
end;
{******************************************************************************}
procedure TMyPlaylist.SetShowDuration(Value: Boolean);
begin
FShowDuration := Value;
Paint;
end;
{******************************************************************************}
procedure TMyPlaylist.SetShowNumber(Value: Boolean);
begin
FShowNumber := Value;
Paint;
end;
{******************************************************************************}
procedure TMyPlaylist.SetPosition(Value: integer);
begin
FPosition := Value;
Paint;
end;
{******************************************************************************}
function TMyPlaylist.GetItemHeight: integer;
begin
Result := ItemHeight;
end;
{******************************************************************************}
function TMyPlaylist.PointInRect(X, Y: Integer; R: TRect): Boolean;
begin
  if (X > R.Left) and (X < R.Right) and (Y > R.Top) and (Y < R.Bottom) then
    Result:= true
  else
    Result:= false;
end;
{******************************************************************************}
procedure TMyPlaylist.DblClick;
begin
if PointInRect(Mouse.CursorPos.X, Mouse.CursorPos.Y, Self.Canvas.ClipRect) then
ShowMessage('!') else
ShowMessage(' !')
end;
{******************************************************************************}

end.
